# This is VERY messy... but was done VERY quickly, and works.

import pygame
import sys

from data import filepath

from BkGlobals import *
import BkMain

from data import filepath

BORDER_X = 10
BORDER_Y = 10


class DifficultyOptions:
	__shared_state = {}
	def __init__(self):
		self.__dict__ = self.__shared_state
		
		try:
			self.bInit
		except:
			self.bInit = True
			self.diffList = [DIFFICULTY_EASY, DIFFICULTY_EASY, DIFFICULTY_EASY, DIFFICULTY_EASY, DIFFICULTY_EASY]	
				
	def getStartWind(self):
		return START_WIND[self.diffList[0]]
		
	def getStartTime(self):
		return START_TIME[self.diffList[1]]
		
	def getWinTime(self):
		return WIN_TIME[self.diffList[2]]
		
	def getWinHeight(self):
		return WIN_HEIGHT[self.diffList[3]]
		
	def getNumBlocks(self):
		return NUM_BLOCKS[self.diffList[4]]		
		
	def setDifficulties(self, diffList):
		self.diffList = diffList
		
	def getDifficulties(self):
		return self.diffList
	
		

class DiffuciltyScreen:
	def __init__(self, iFontSize):	
		self.bQuit = False
		bOpen = True
		
		updateRect = self.setupScreen(iFontSize)
		
		while bOpen:
			for event in pygame.event.get():
				if event.type == pygame.QUIT:
					sys.exit(0)
				elif event.type == pygame.KEYDOWN:
					if event.dict["key"] == pygame.K_ESCAPE:
						bOpen = False
					elif event.dict["key"] == pygame.K_F4:
						if pygame.key.get_mods() & pygame.KMOD_LALT or pygame.key.get_mods() & pygame.KMOD_RALT:
							sys.exit(0)		
				elif event.type == pygame.MOUSEMOTION:
					pos = event.dict["pos"]
					
					pygame.display.update(self.updateScreen(pos, False))
					break
				elif event.type == pygame.MOUSEBUTTONUP:
					if event.dict["button"] == 1:				
					
						pygame.display.update(self.updateScreen(pos, True))
						
						if self.bQuit:
							bOpen = False
						break
						
						
	def setupScreen(self, iFontSize = 24):
		font = pygame.font.Font(FONTPATH, iFontSize)

		easySurf = font.render("Easy", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highEasySurf = font.render("Easy", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedEasySurf = font.render("Easy", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		self.easySurfs = (easySurf, highEasySurf, selectedEasySurf)
		
		mediumSurf = font.render("Medium", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highMediumSurf = font.render("Medium", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedMediumSurf = font.render("Medium", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		self.mediumSurfs = (mediumSurf, highMediumSurf, selectedMediumSurf)		
		
		hardSurf = font.render("Hard", True, TEXT_NORMAL_COLOUR).convert_alpha()
		highHardSurf = font.render("Hard", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()
		selectedHardSurf = font.render("Hard", True, TEXT_DANGER_COLOUR).convert_alpha()
		
		self.hardSurfs = (hardSurf, highHardSurf, selectedHardSurf)			
				
		startWindSurf = font.render("Start Wind:", True, TEXT_NORMAL_COLOUR).convert_alpha()
		startTimeSurf = font.render("Game Time:", True, TEXT_NORMAL_COLOUR).convert_alpha()
		winTimeSurf = font.render("Win Time:", True, TEXT_NORMAL_COLOUR).convert_alpha()
		winHeightSurf = font.render("Win Height:", True, TEXT_NORMAL_COLOUR).convert_alpha()
		numBlocksSurf = font.render("No. Blocks:", True, TEXT_NORMAL_COLOUR).convert_alpha()
			
		self.exitSurf = font.render("Exit", True, TEXT_NORMAL_COLOUR).convert_alpha()
		self.highExitSurf = font.render("Exit", True, TEXT_HIGHLIGHT_COLOUR).convert_alpha()		

		self.surfList = (startWindSurf, startTimeSurf, winTimeSurf, winHeightSurf, numBlocksSurf)
			
		self.iTotalHeight = iTotalHeight = 7 * easySurf.get_height()
		self.iOptionWidth = iOptionWidth = max(startWindSurf.get_width(), startTimeSurf.get_width(), winTimeSurf.get_width(), winHeightSurf.get_width(), numBlocksSurf.get_width())
		self.iSelectionWidth = iSelectionWidth = easySurf.get_width() + BORDER_X + mediumSurf.get_width() + BORDER_X + hardSurf.get_width()
			
		if iOptionWidth + iSelectionWidth + 6 * BORDER_X > pygame.display.get_surface().get_width() or iTotalHeight + 2 * BORDER_Y > pygame.display.get_surface().get_height():
			return self.setupScreen(iFontSize - 1)	
			
		self.mainSurf = pygame.Surface((iOptionWidth + iSelectionWidth + 6 * BORDER_X, iTotalHeight + 4 * BORDER_Y)).convert()
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, iOptionWidth + iSelectionWidth + 4 * BORDER_X, iTotalHeight + 2 * BORDER_Y))
		self.pos = (pygame.display.get_surface().get_width() - self.mainSurf.get_width()) / 2, (pygame.display.get_surface().get_height() - self.mainSurf.get_height()) / 2
		
		return pygame.display.get_surface().blit(self.mainSurf, self.pos)
		
	def updateScreen(self, pos, bClick):
		self.mainSurf.fill(NEXT_BLOCK_BG_COLOUR)
		self.mainSurf.fill(OPTIONS_BG_COLOUR, (BORDER_X, BORDER_Y, self.iOptionWidth + self.iSelectionWidth + 4 * BORDER_X, self.iTotalHeight + 2 * BORDER_Y))

		i = 0
		
		diffOpts = DifficultyOptions()
		difficulties = diffOpts.getDifficulties()
		
		for surf in self.surfList:
			blitPos = ((2 * BORDER_X), BORDER_Y + (i * self.iTotalHeight / (len(self.surfList) + 2)))
			
			self.mainSurf.blit(surf, blitPos)
			
			blitPos = ((4 * BORDER_X + self.iOptionWidth), BORDER_Y + (i * self.iTotalHeight / (len(self.surfList) + 2)))
			if self.easySurfs[0].get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
				self.mainSurf.blit(self.easySurfs[1], blitPos)
				if bClick:
					difficulties[i] = DIFFICULTY_EASY
					diffOpts.setDifficulties(difficulties)
			elif difficulties[i] == DIFFICULTY_EASY:
				self.mainSurf.blit(self.easySurfs[2], blitPos)
			else:
				self.mainSurf.blit(self.easySurfs[0], blitPos)
				
			blitPos = ((blitPos[0] + BORDER_X + self.easySurfs[0].get_width()), BORDER_Y + (i * self.iTotalHeight / (len(self.surfList) + 2)))
			
			if self.mediumSurfs[0].get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
				self.mainSurf.blit(self.mediumSurfs[1], blitPos)
				if bClick:
					difficulties[i] = DIFFICULTY_MEDIUM
					diffOpts.setDifficulties(difficulties)
					
			elif difficulties[i] == DIFFICULTY_MEDIUM:
				self.mainSurf.blit(self.mediumSurfs[2], blitPos)
			else:
				self.mainSurf.blit(self.mediumSurfs[0], blitPos)	

			blitPos = ((blitPos[0] + BORDER_X + self.mediumSurfs[0].get_width()), BORDER_Y + (i * self.iTotalHeight / (len(self.surfList) + 2)))
			
			if self.hardSurfs[0].get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
				self.mainSurf.blit(self.hardSurfs[1], blitPos)
				if bClick:
					difficulties[i] = DIFFICULTY_HARD
					diffOpts.setDifficulties(difficulties)				
					
			elif difficulties[i] == DIFFICULTY_HARD:
				self.mainSurf.blit(self.hardSurfs[2], blitPos)
			else:
				self.mainSurf.blit(self.hardSurfs[0], blitPos)					
			
			
			i += 1
			
		blitPos = ((self.mainSurf.get_width() - self.exitSurf.get_width()) / 2, BORDER_Y + (i * self.iTotalHeight / (len(self.surfList) + 1)))		
			
		if self.exitSurf.get_rect(left = blitPos[0] + self.pos[0], top = blitPos[1] + self.pos[1]).collidepoint(pos):
			self.mainSurf.blit(self.highExitSurf, blitPos)
			if bClick:
				self.bQuit = True			
		else:
			self.mainSurf.blit(self.exitSurf, blitPos)
			
		return pygame.display.get_surface().blit(self.mainSurf, self.pos)
			